﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace XDT_NLevelHeirarchy_SL4
{
    public partial class MainPage : UserControl
    {

        //the number of levels in the hierarchy
        private int treeDepth = 5;

        //the number of children of each node
        private int levelNodeCount = 2;
        private SimpleNodeDataSource viewModel;

        public MainPage()
        {
            InitializeComponent();
            Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            viewModel = new SimpleNodeDataSource();
            DataContext = this.viewModel;

            this.LoadDataSource();
        }

        private void LoadDataSource()
        {
            IList<SimpleNode> nodes = new List<SimpleNode>();
            SetNodes(nodes, 0);
            viewModel.SimpleNodes = nodes;
        }

        /// <summary>
        /// Recursively populate a tree structure
        /// </summary>
        /// <param name="nodes"></param>
        /// <param name="level"></param>
        private void SetNodes(IList<SimpleNode> nodes, int level)
        {
            if (level == treeDepth)
                return;
            SimpleNode sn;
            for (int i = 0; i < levelNodeCount; ++i)
            {
                sn = new SimpleNode();
                sn.Text = "Node " + (i + 1).ToString() + ":Level " + level.ToString();
                sn.Children = new List<SimpleNode>();
                SetNodes(sn.Children, level + 1);
                nodes.Add(sn);
            }
        }
    }
}
